module Swagger

  class Configuration
    require 'swagger/version'    
    
    attr_accessor :format, :api_key, :username, :password, :auth_token, :scheme, :host, :base_path, :user_agent, :logger, :inject_format, :force_ending_format, :camelize_params
    
    # Defaults go in here..
    def initialize
      @format = 'json'
      @scheme = 'http'
      @host = 'api.wordnik.com'
      @base_path = '/v4'
      @user_agent = "ruby-#{Swagger::VERSION}"
      @inject_format = true
      @force_ending_format = false
      @camelize_params = true
    end

  end

end